package com.joelhelkala.watcherGui.Nodes;

import java.util.ArrayList;
import java.util.List;

import com.joelhelkala.watcherGui.Nodes.Node.Node;
import com.joelhelkala.watcherGui.httpRequests.HttpRequests;

/*
 * Class to handle nodes
 */
public class Nodes {
	// list of the nodes
	private static List<Node> nodes = new ArrayList<Node>();
	
	// Add a list of nodes 
	public static void AddNodes(List<Node> list) {
		for(Node n : list) {
			AddNode(n);
		}
	}
	
	// Add a node to nodes list
	public static void AddNode(Node node) {
		nodes.add(node);
	}
	
	// get the amount of nodes
	public static int size() {
		return nodes.size();
	}
	
	// get the node at given index
	public static Node get(int index) {
		return nodes.get(index);
	}
	
	// get all of the nodes
	public static List<Node> getAll() {
		return nodes;
	}

	// get a node which matches the location given
	public static Node findByLocation(String location) {
		for(Node n : nodes) {
			if(n.getLocation() == location) return n;
		}
		return null;
	}
	
	// reset nodes and get updated ones from server
	public static void updateNodes() {
		nodes.clear();
		AddNodes(HttpRequests.getNodes());
	}
}
