package com.joelhelkala.watcherGui.frames.subframes;

import java.awt.Color;


import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTextField;

import com.joelhelkala.watcherGui.Nodes.Node.Node;
import com.joelhelkala.watcherGui.User.User;
import com.joelhelkala.watcherGui.frames.LoginPage;
import com.joelhelkala.watcherGui.frames.WelcomePage;
import com.joelhelkala.watcherGui.httpRequests.HttpRequests;

import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.*;

/*
 * A tab for updating nodes
 */
public class NodeSettingsFrame extends JPanel implements ActionListener{
	private static final Color gray = new Color(45, 45, 45);
	private JTextField descField = new JTextField();
	private JTextField locationField = new JTextField();
	private JTextField latField = new JTextField();
	private JTextField lonField = new JTextField();
	private Node current_node = null;
	
	private JButton reset_btn;
	private JButton save_btn;
	
	
	// Costructor
	public NodeSettingsFrame(int width, int height) {
		setLayout(null);
		setBounds(0,0,width,height);
		setOpaque(true);
		setBackground(gray);
		
		JLabel descLabel = new JLabel("Description");
		descLabel.setForeground(Color.white);
		descLabel.setBounds(10,10, 100, 30);
		descField.setBounds(120, 10, 200, 30);
		add(descLabel);
		add(descField);
		
		JLabel locationLabel = new JLabel("Location");
		locationLabel.setForeground(Color.white);
		locationLabel.setBounds(10,50, 100, 30);
		locationField.setBounds(120, 50, 200, 30);
		add(locationLabel);
		add(locationField);
		
		JLabel latLabel = new JLabel("Latitude");
		latLabel.setForeground(Color.white);
		latLabel.setBounds(10,90, 100, 30);
		latField.setBounds(120, 90, 200, 30);
		add(latLabel);
		add(latField);
		
		JLabel lonLabel = new JLabel("Longitude");
		lonLabel.setForeground(Color.white);
		lonLabel.setBounds(10,130, 100, 30);
		lonField.setBounds(120, 130, 200, 30);
		add(lonLabel);
		add(lonField);
		
		reset_btn = new JButton("Reset");
		save_btn = new JButton("Save");
		reset_btn.addActionListener(this);
		save_btn.addActionListener(this);
		
		reset_btn.setBounds(width/4, height-200, 50, 20);
		save_btn.setBounds(width/2, height-200, 50, 20);
		add(reset_btn);
		add(save_btn);
	}

	// Updates the textfields according to the given node
	public void updateInformation(Node node) {
		current_node = node;
		descField.setText(node.getDescription());
		locationField.setText(node.getLocation());
		latField.setText(node.getLatitude().toString());
		lonField.setText(node.getLongitude().toString());
	}
	
	// Saves the current information from the textlabels
	// A confirmation window is prompted
	private void saveInformation() {
		boolean save = WelcomePage.handleSave();
		if(save && current_node != null) {
			boolean success = HttpRequests.updateNode(new Node(descField.getText(),
									Float.parseFloat(latField.getText()),
									Float.parseFloat(lonField.getText()),
									locationField.getText(),
									current_node.getId()));
			if(!success) {
				WelcomePage.ErrorDialog();
				return;
			}
			WelcomePage.updateComboBox();
		}
	}
	
	/*
	 * Validates all the textfields and returns
	 * a boolean based on if all are valid
	 */
	private boolean validFields() {
		// TODO: create implementation
		return true;
	}

	// This handles the reset and save button clicks
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == reset_btn) {
			updateInformation(current_node);
		} else if(e.getSource() == save_btn) {
			if(validFields()) saveInformation();
		}
	}
}